#include <qblib/stream.hh>

class InputImplement: public InputStreamBase
{
protected:
    bool InputError;
    bool GotEOL;
public:
    virtual void InputTo(BAS_INT& target);
    virtual void InputTo(BAS_SGN& target);
    virtual void InputTo(BAS_DBL& target);
    virtual void InputTo(BAS_LNG& target);
    virtual void InputTo(BAS_STR& target);
    
protected:
    virtual int InputChar() = 0;
    virtual void GotOverflow() = 0;

    long double InputLong();
    bool FinishInput();
};
