#ifndef bqtQBlibDataHH
#define bqtQBlibDataHH

#include <qblib/types.hh>
#include <qblib/basfun.hh>
#include <qblib/error.hh>

#define B_RESTORE(n) DATA_PTR=(n)

#define B_READ(target) \
    if(unlikely(DATA_PTR >= DATA_COUNT)) { B_ERROR(4); } /*OUT OF DATA*/ \
    else B_READ_DO(target, DATA_TABLE[DATA_PTR++]);

void B_READ_DO(BAS_DBL& target, const char* input);
void B_READ_DO(BAS_LNG& target, const char* input);
void B_READ_DO(BAS_INT& target, const char* input);
void B_READ_DO(BAS_SGN& target, const char* input);
void B_READ_DO(BAS_BYTE& target, const char* input);
void B_READ_DO(BAS_UBYTE& target, const char* input);
void B_READ_DO(BAS_UINT& target, const char* input);
void B_READ_DO(BAS_ULONG& target, const char* input);

static inline void B_READ_DO(BAS_STR& target, const char* input) { target = input; }

#endif
