#include <cmath>
#include <qblib/basfun.hh>

static inline double B_FuncCOS(double n) { return std::cos(n); }
static inline double B_FuncSIN(double n) { return std::sin(n); }
static inline double B_FuncATN(double n) { return std::atan(n); }
static inline double B_FuncTAN(double n) { return std::tan(n); }
static inline double B_FuncSQR(double n) { return std::sqrt(n); }
static inline double B_FuncABS(double n) { return std::fabs(n); }

static inline float B_FuncCOS(float n) { return std::cos(n); }
static inline float B_FuncSIN(float n) { return std::sin(n); }
static inline float B_FuncATN(float n) { return std::atan(n); }
static inline float B_FuncTAN(float n) { return std::tan(n); }
static inline float B_FuncSQR(float n) { return std::sqrt(n); }
static inline float B_FuncABS(float n) { return std::fabs(n); }

template<typename T>
static inline T B_FuncABS(T n) { return n < 0 ? -n : n; }

#define B_FuncCLNG BasCLNG
#define B_FuncCINT BasCINT
#define B_FuncINT  BasINT
